package org.netkernel.lang.dpml.ast;

public interface IArgument
{
	//default- references and closures are passed lazily, literals are passed eagerly
	static final int METHOD_DEFAULT=0;
	// eager- closure is evaluated, reference is sourced before passing
	static final int METHOD_EAGER=1;
	// lazy- closure is referenced, reference is passed
	static final int METHOD_LAZY=2;
	// identity- similar to eager but argument is serialized into data: uri
	static final int METHOD_IDENTITY=3;
	
	// name of primary argument for sink and new requests
	static final String ARG_PRIMARY="primary";
	// name of argument containing verb of enclosing closure
	static final String ARG_VERB="verb";
	// name of argument containing HDS representation of all arguments passed in
	static final String ARG_ARGUMENTS="arguments";
	
	
	int getMethod();
	String getName();
	IVariable getVariable();
}
